

::************************************************************************************************************************
::					IBM Rational Hot-Fix Installer for "SoDA Word" product
::************************************************************************************************************************


@echo off

::First test to see if we are on NT or similar OS
::The ony difference is how they handle the ampersand
::> ~strTestOS.vbs echo 1234&rem

Set RATIONAL_OS = WIN9X
 > ~strTestOS.vbs echo 1234&rem
type ~strTestOS.vbs | find "rem" > nul
if errorlevel 1 set RATIONAL_OS=WINNT
del ~strTestOS.vbs

 > ~strMain.vbs echo. 
>> ~strMain.vbs echo. Dim sourceDir, strDrive, targetFiles, fs, regKey, returnButton, backupSuffixName
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Private Function chkAndProceed()
>> ~strMain.vbs echo.     Dim suffixMsgStr, returnButton, msg
>> ~strMain.vbs echo.    
>> ~strMain.vbs echo.     chkAndProceed = "No"
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     sourceDir = fs.GetAbsolutePathName(Wscript.ScriptFullName + "\..")
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.     If Not (Mid(sourceDir,Len(sourceDir)) = "\") Then sourceDir = sourceDir + "\"   
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.     msg = ""
>> ~strMain.vbs echo.     If (fs.FolderExists(sourceDir)) Then
>> ~strMain.vbs echo.         For Each file In targetFiles
>> ~strMain.vbs echo.             If Not (fs.FileExists(sourceDir + file)) Then
>> ~strMain.vbs echo.                 If Not msg = "" Then msg = msg + ", "
>> ~strMain.vbs echo.                 msg = " " + msg + file
>> ~strMain.vbs echo.             End If
>> ~strMain.vbs echo.         Next
>> ~strMain.vbs echo.         If Not msg = "" Then msg = "Source directory...[ " + sourceDir + " ]" + Chr(13) + msg
>> ~strMain.vbs echo.     Else
>> ~strMain.vbs echo.         MsgBox "Source directory doesn't exists. [ " + sourceDir + " ]" + Chr(13) + " Please execute this batch file from the location where you have extracted the hot-fix components.",vbOKOnly + vbCritical,"IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo. 	Exit Function
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     If InStr(1, msg, "Source", vbTextCompare) Then
>> ~strMain.vbs echo.         MsgBox "Following components are missing in..." + Chr(13) + msg + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.         "Make sure you are running the Hot-Fix Installer " + Chr(13) + _
>> ~strMain.vbs echo.         "from the directory that contains the SoDAWord folder with other components.", _
>> ~strMain.vbs echo.         vbOKOnly + vbCritical, _
>> ~strMain.vbs echo.         "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo.         Exit Function
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. '    strDrive = fs.GetAbsolutePathName(strDrive + "\..")
>> ~strMain.vbs echo.     If Not (Mid(strDrive,Len(strDrive)) = "\") Then strDrive = strDrive + "\"   
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.     msg = ""
>> ~strMain.vbs echo.     If (fs.FolderExists(strDrive)) Then
>> ~strMain.vbs echo.         For Each file In targetFiles
>> ~strMain.vbs echo.             If Not (fs.FileExists(strDrive + file)) Then
>> ~strMain.vbs echo.                 If Not msg = "" Then msg = msg + ", "
>> ~strMain.vbs echo.                 msg = " " + msg + file
>> ~strMain.vbs echo.             End If
>> ~strMain.vbs echo.         Next
>> ~strMain.vbs echo.         If Not msg = "" Then msg = "Target directory...[ " + strDrive  + " ]" + Chr(13) + msg
>> ~strMain.vbs echo.     Else
>> ~strMain.vbs echo. 	MsgBox "Target directory doesn't exists. [" + strDrive + "]" + Chr(13) + " Please provide the valid home directory of 'Rational Software'.",vbOKOnly + vbCritical,"IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo.         Exit Function
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.    
>> ~strMain.vbs echo.     If InStr(1, msg, "Target", vbTextCompare) Then
>> ~strMain.vbs echo.         returnButton = MsgBox("Following components are missing in..." + Chr(13) + msg + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.                         "Please provide the valid home directory of 'Rational Software'.", vbOkOnly + vbDefaultButton1 + vbCritical, _
>> ~strMain.vbs echo.                         "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12")
>> ~strMain.vbs echo. 	Exit Function
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     chkAndProceed = "Yes"
>> ~strMain.vbs echo.         
>> ~strMain.vbs echo. End Function
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Private Function getBackupSuffix()
>> ~strMain.vbs echo.     Dim tmpStr
>> ~strMain.vbs echo.     Do
>> ~strMain.vbs echo.     	tmpStr = InputBox("Your original files will be backed-up by renaming the files during the Hot-Fix Install process." + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.         	"Type the file-extension that you wish to append to the end of your original files to create the backups. -- This input is required. --" + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo. 	        "Example: backup_01", "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12", "backup_01")
>> ~strMain.vbs echo.     Loop While tmpStr = "" And  (Not IsEmpty(tmpStr))
>> ~strMain.vbs echo.     getBackupSuffix = tmpStr
>> ~strMain.vbs echo. End Function
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Public Sub applyPatchMain()
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. On Error Resume Next
>> ~strMain.vbs echo. Err.Clear
>> ~strMain.vbs echo. strDrive = ""
>> ~strMain.vbs echo. targetFiles = ""
>> ~strMain.vbs echo. backupSuffixName = ""
>> ~strMain.vbs echo. strBackup = "No"
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. targetFiles = Array("sodaword\SoDAWord2000.dll", "sodaword\SoDAWord2002.dll", "sodaword\SoDAWord2003.dll")
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Set Sh = CreateObject("WScript.Shell")
>> ~strMain.vbs echo. regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Rational Software\SoDAWord\SODA_HOME"	'	SoDA Word home directory regkey
>> ~strMain.vbs echo. 'regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Rational Software\RSINSTALLDIR"   	'	Rational home directory regkey
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. strDrive = Sh.RegRead(regKey)
>> ~strMain.vbs echo. If Not Err = 0 Then
>> ~strMain.vbs echo. 	strDrive = ""
>> ~strMain.vbs echo. End If
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Set fs = CreateObject("Scripting.FileSystemObject")
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.     If Not (strDrive = "") Then
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. 	strDrive = fs.GetAbsolutePathName(strDrive + "\..")
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.         returnButton = MsgBox("Hot-Fix Installer for SoDA Word-20040430." + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.             "the Hot-Fix Installer will install the files: SoDAWord2000.dll, SoDAWord2002.dll, SoDAWord2003.dll. " + Chr(13) + _
>> ~strMain.vbs echo.             "(included with this Hot-Fix)" + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.             "Make sure you are running the Hot-Fix Installer from the directory where you " + Chr(13) + _
>> ~strMain.vbs echo.             " extracted the new SoDA Word DLLs." + Chr(13) + Chr(13) + "Hot-Fix Installer found the Rational Software home directory on this system." + Chr(13) + _
>> ~strMain.vbs echo.             "  SoDA home : ' " + strDrive + " '" + Chr(13) + Chr(13) + " Do you want to continue in applying the Hot-Fix?", vbOkCancel + vbSystemModal + vbDefaultButton1, _
>> ~strMain.vbs echo.             "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12")
>> ~strMain.vbs echo.         If returnButton = vbCancel Then
>> ~strMain.vbs echo. 	    Exit Sub
>> ~strMain.vbs echo. 	End if
>> ~strMain.vbs echo.     Else
>> ~strMain.vbs echo.     	Do
>> ~strMain.vbs echo.             strDrive = InputBox("Hot-Fix Installer for SoDA Word-20040430." + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.         	    "Hot-Fix Installer is unable to find the Rational Software home directory." + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.         	    "Type the drive letter and path where the Rational Software is installed. -- This input is required. --" + Chr(13) + Chr(13) + _
>> ~strMain.vbs echo.         	    "Example: C:\Program Files\Rational", "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12", "C:\Program Files\Rational")
>> ~strMain.vbs echo. 	Loop While strDrive = "" And (Not IsEmpty(strDrive))
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     If Not ((strDrive = "") And IsEmpty(strDrive)) Then
>> ~strMain.vbs echo. '        If Not (Mid(strDrive,Len(strDrive)) = "\") Then strDrive = strDrive + "\"
>> ~strMain.vbs echo.         strBackup = chkAndProceed()
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.    
>> ~strMain.vbs echo.     If strBackup = "Yes" Then backupSuffixName = getBackupSuffix()
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     If Not backupSuffixName = "" Then
>> ~strMain.vbs echo.     	backupDone = doBackupTargetFiles()
>> ~strMain.vbs echo.         If  backupDone = "Done" Then
>> ~strMain.vbs echo.             applyPatch
>> ~strMain.vbs echo.         End If
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo.     If ((strDrive = "") And IsEmpty(strDrive)) OR ((backupSuffixName = "") And IsEmpty(backupSuffixName)) Then
>> ~strMain.vbs echo. 	MsgBox "Hot-Fix Installer SoDA Word-20040430 has been cancelled!!", vbOKOnly + vbInformation, "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. End Sub
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Private Function doBackupTargetFiles()
>> ~strMain.vbs echo. On Error Resume Next
>> ~strMain.vbs echo.     doBackupTargetFiles = "Not"
>> ~strMain.vbs echo.     flgFileBackup = "No"
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     curTimeStamp = Now
>> ~strMain.vbs echo.     curTimeStamp = CStr(Year(curTimeStamp)) + CStr(Month(curTimeStamp)) + CStr(Day(curTimeStamp)) + "." + CStr(Hour(curTimeStamp)) + CStr(Minute(curTimeStamp))
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     For Each file In targetFiles
>> ~strMain.vbs echo. 	If fs.FileExists(strDrive + file + "_" + backupSuffixName ) Then
>> ~strMain.vbs echo. 		flgFileBackup = "Yes"
>> ~strMain.vbs echo. 		Exit For
>> ~strMain.vbs echo. 	End If
>> ~strMain.vbs echo.     Next
>> ~strMain.vbs echo.     If flgFileBackup = "Yes" Then
>> ~strMain.vbs echo.     	MsgBox "Hot-Fix Installer found some of the components exists with the suffix which you have provided [" + backupSuffixName + "], " + chr(13) + _
>> ~strMain.vbs echo.     	"to maintain the old copies Hot-Fix Installer backups the components by appending timestamp [" + curTimeStamp + "] into the name.", vbOKOnly + vbInformation, "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo.     	backupSuffixName = backupSuffixName + "_" + curTimeStamp
>> ~strMain.vbs echo.     End If
>> ~strMain.vbs echo.     For Each file In targetFiles
>> ~strMain.vbs echo.         fs.CopyFile strDrive + file, strDrive + file + "_" + backupSuffixName, True
>> ~strMain.vbs echo.     Next
>> ~strMain.vbs echo.     doBackupTargetFiles = "Done"
>> ~strMain.vbs echo. End Function
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. Private Sub applyPatch()
>> ~strMain.vbs echo. On Error Resume Next
>> ~strMain.vbs echo.     
>> ~strMain.vbs echo.     Dim oShell
>> ~strMain.vbs echo.     Set oShell = Wscript.CreateObject("WSCript.shell")
>> ~strMain.vbs echo.     For Each file In targetFiles
>> ~strMain.vbs echo.     	Err.Clear
>> ~strMain.vbs echo.     	fs.CopyFile sourceDir + file, strDrive + file, True
>> ~strMain.vbs echo. '        Select Case fs.GetExtensionName(strDrive + file)
>> ~strMain.vbs echo.         Select Case file
>> ~strMain.vbs echo.         	Case "xmlgen.dll"
>> ~strMain.vbs echo. 		'	Msgbox strDrive + " : " + file + " : " + fs.GetExtensionName(strDrive + file)
>> ~strMain.vbs echo.             		oShell.run "regsvr32 /s """ + strDrive + file + """"
>> ~strMain.vbs echo.             	'	oShell.run "copy " + strDrive + file + " " + strDrive + file + "_2"
>> ~strMain.vbs echo.     	End Select        	
>> ~strMain.vbs echo.     Next
>> ~strMain.vbs echo.     Set oShell = Nothing
>> ~strMain.vbs echo.     MsgBox "Hot-Fix Installer for SoDA Word-20040430 applied successfully!", vbOKOnly + vbExclamation , "IBM Rational Hot-Fix Installer for SoDA Word 2003.06.12"
>> ~strMain.vbs echo. End Sub
>> ~strMain.vbs echo. 
>> ~strMain.vbs echo. applyPatchMain

@echo Please wait....

::run
::Now run the created script
::Now call the created batch file s
start /w wscript.exe ~strMain.vbs
del ~strMain.vbs

